version: "3"
services:
  db:
    # restart: always
    build:
      context: ./db
      dockerfile: Dockerfile
    # image: 'registry.gitlab.com/multibook-kl5-2021/multibook-kl5-${TYPE}-test.mac.pl:${VERSION}'
    container_name: "mongodb"
    ports:
      - "27017:27017"
    environment:
      - MONGO_INITDB_ROOT_USERNAME=user
      - MONGO_INITDB_ROOT_PASSWORD=user123
      - MONGO_INITDB_DATABASE=przemodb
    volumes:
      - big-app-mongodb:/data/db
    networks:
      - fantastic

  app:
    build:
      context: ./app
      dockerfile: Dockerfile
    depends_on:
      - db
    container_name: "fantastic-app"
    ports:
      - "8081:8081"
    environment:
      - NODE_ENV=development
    volumes:
      - ./app:/app
      - ./ssl:/ssl
    networks:
      - fantastic

  api:
    build:
      context: ./api
      dockerfile: Dockerfile
    depends_on:
      - db
    container_name: "fantastic-api"
    ports:
      - "5000:5000"
      - "4999:4999"
    environment:
      - NODE_ENV=development
    volumes:
      - ./api:/api
      - ./ssl:/ssl
    networks:
      - fantastic

  # postgres:
  #   image: postgres
  #   container_name: 'keycloak-postgers'
  #   volumes:
  #     - postgres_data:/var/lib/postgresql/data
  #   environment:
  #     POSTGRES_DB: keycloak
  #     POSTGRES_USER: keycloak
  #     POSTGRES_PASSWORD: password
  #   networks:
  #     - keycloak
  keycloak:
    # restart: always
    # image: 'sso'
    image: jboss/keycloak:11.0.1
    container_name: 'fantastic-keycloak'
    # hostname: 'sso'
    environment:
      # KEYCLOAK_WELCOME_THEME: mac
      # DB_VENDOR: POSTGRES
      # DB_ADDR: postgres
      # DB_DATABASE: keycloak
      # DB_USER: keycloak
      # DB_PASSWORD: password
      KEYCLOAK_USER: admin
      KEYCLOAK_PASSWORD: admin
      # Uncomment the line below if you want to specify JDBC parameters. The parameter below is just an example, and it shouldn't be used in production without knowledge. It is highly recommended that you read the PostgreSQL JDBC driver documentation in order to use it.
      #JDBC_PARAMS: "ssl=true"
    ports:
      - 8080:8080
    # volumes:
      # - ./ssl:/etc/x509/https
      # - ./keycloak/mac:/opt/jboss/keycloak/themes/mac
      # - ./keycloak/keycloak:/opt/jboss/keycloak/themes/keycloak
    # depends_on:
    #   - postgres
    networks:
      # - jimsk3-net
      - fantastic
      - keycloak
volumes:
  big-app-mongodb:
    driver: local
  postgres_data:
    driver: local
networks:
  fantastic:
  keycloak:
